/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Professional
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 07.04.2009
Author  : Dikoy                           
Company : NT                              
Comments: 


Chip type           : ATmega48V
Clock frequency     : 1,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega48(V)


#pragma used+
#pragma used+
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   // 16 bit access
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb MONDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.SET power_ctrl_reg=smcr
	#endif
#endasm


/*
  CodeVisionAVR C Compiler
  (C) 1998-2007 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for power management functions
*/


// CodeVisionAVR C Compiler
// (C) 1998-2007 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions


// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega48(V)






										




#pragma used+
#pragma used+
#pragma used+
#pragma used+
void sleep_enable(void);
void sleep_disable(void);
void idle(void);

void powerdown(void);

void powersave(void);


void standby(void);

#pragma used-

#pragma library sleep.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-





// *** ***
unsigned char temp, time_of_pressed;      
unsigned char sleep_mode_flag = 0;  
unsigned char ALARM_flag = 0;
unsigned char sequrity_flag = 0; 
unsigned char zero_X, zero_Y, zero_Z, zero_R;
unsigned char min_X, min_Y, min_Z;
unsigned char max_X, max_Y, max_Z;
unsigned int  alarm_count = 0;  
unsigned char bt_flag = 0;  

unsigned int button_count = 0;
unsigned int but_count = 0;

//unsigned char first_flag = 1;  

// ****** 

// Pin change 0-7 interrupt service routine
interrupt [4] void pin_change_isr0(void)
{  
if(sequrity_flag == 0) {
        while(( !(PINB & (1<<0)) )  );    
        sleep_mode_flag = 1;  
        #asm("cli")
        delay_ms(500); 
        }
}


// Watchdog timeout interrupt service routine
interrupt [7] void wdt_timeout_isr(void) {  

        #asm("nop")

}

void wdt_start(void) {
        // Watchdog Timer initialization
        // Watchdog Timer Prescaler: OSC/64k
        // Watchdog Timer interrupt: On
        #pragma optsize-
        #asm("wdr")
        (*(unsigned char *) 0x60) = (1<<4) | (1<<3);  // (1<<WDCE) | (1<<WDE)
        (*(unsigned char *) 0x60) = (1<<6) | (1<<2) | (1<<0);  // (1<<WDIE) | (1<<WDP2) | (1<<WDP0)      
        
                        
        // Global enable interrupts
        #asm("sei")
}


void wdt_stop(void) {
        #pragma optsize-
        #asm("wdr")
        (*(unsigned char *) 0x60) = (1<<4) | (1<<3);  // (1<<WDCE) | (1<<WDE)
        (*(unsigned char *) 0x60) = 0;   
                        
        #asm("cli")
}



// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_par)
{
(*(unsigned char *) 0x7c) = adc_par;
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
(*(unsigned char *) 0x7a)|=0x40;
// Wait for the AD conversion to complete
while (((*(unsigned char *) 0x7a) & 0x10)==0);
(*(unsigned char *) 0x7a)|=0x10;
return (*(unsigned char *) 0x79);
}  


void start_PWM(void) {    
// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: CTC top=OCR0A
// OC0A output: Disconnected
// OC0B output: Toggle on compare match
TCCR0A=0x12;
TCCR0B=0x01;
}
   
void PWM_stop(void) {     
TCCR0A=0x00;
TCCR0B=0x00;

PORTD &= ~(1<<5);
}     
     

void Step_Up_Process(void) { 
unsigned char u_fb;   

        u_fb = read_adc(0xE0   | 7);

        if( u_fb < (226+10)    ) start_PWM();
        if( u_fb > (228+10)    ) PWM_stop();
} 


void Go_To_Sleep(void) {    
        PORTD |= (1<<1);
        PWM_stop();
        wdt_stop();
        PORTC&=~(1<<5) ;
        DDRB&=~(1<<5);
        delay_ms(600);
        DDRB&=~(1<<7); 
        PORTD &= ~(1<<1);    
        sequrity_flag = 0;
        ALARM_flag = 0;  
        button_count = 0;  
        but_count = 0;
        bt_flag = 0;     
        (*(unsigned char *) 0x7c) = 0x00;       //      .
        (*(unsigned char *) 0x7a) = 0x00;
        while(( !(PINB & (1<<0)) )  );
        delay_ms(3000);      
        #asm("sei")
        powerdown();
}


void StartUp(void) {
unsigned char i, data;  
unsigned char limit = 0;     
                
                (*(unsigned char *) 0x7a) = 0x81;  //  
                delay_ms(10);
                i = read_adc(0x60   | 0x0E);   //      
                 
                  PORTD |= (1<<1);   
                  delay_ms(250);
                  data = read_adc(0x60   | 0x0E); //           
                  PORTD &= ~(1<<1);    
                  delay_ms(250);
                          
                (*(unsigned char *) 0x7c) = 0x00;       //      .
                (*(unsigned char *) 0x7a) = 0x00;
                
                        if( data > 107 ) limit = 1; //     2,6 ...
                        if( data > 117 ) limit = 2; //     2,4 ...
                        if( data > 127 ) limit = 5; //     2,2 ... 

                        for(i=0;i<limit;i++) {  //  .
                                PORTD |= (1<<1);
                                delay_ms(250);
                                PORTD &= ~(1<<1);    
                                delay_ms(250);
                                } 
                                                                
                        delay_ms(1500); 
                        
                        if( data > 127 ) { //   ,
                                          Go_To_Sleep(); // ...
                                         }
} 

   

char Prepare_of_sequrity(void) { 
unsigned char i_pr;                         
                
                         //  
                        (*(unsigned char *) 0x7a) = 0x81; 
                                                                
                        delay_ms(500); 

                        temp = read_adc(0x60   | 6); //            

                        for(i_pr=0;i_pr<15;i_pr++) {  //   15 .
                                PORTD |= (1<<1);
                                delay_ms(100);
                                PORTD &= ~(1<<1);    
                                delay_ms(900);
                                } 
                                
                        PORTC|=(1<<5)  ; //  
                        DDRB|=(1<<5); //  
                        delay_ms(10); //           
                        
                        zero_R = read_adc(0x60   | 6);    
                          if(zero_R < 20) zero_R = 20; // ,     .
                         
                        zero_X = read_adc(0x60   | 2                               ); 
                          min_X = (zero_X - (zero_R / 4));       
                          max_X = (zero_X + (zero_R / 4));   
                           
                        zero_Y = read_adc(0x60   | 3); 
                          min_Y = (zero_Y - (zero_R / 4));       
                          max_Y = (zero_Y + (zero_R / 4));   
                           
                        zero_Z = read_adc(0x60   | 4);  
                          min_Z = (zero_Z - (zero_R / 4));       
                          max_Z = (zero_Z + (zero_R / 4));   
                           
                                  
                        DDRB&=~(1<<5); //  
                        PORTC&=~(1<<5) ; //    
                        PWM_stop();    //  PWM (  )
                        DDRB&=~(1<<7);   //    
                        PORTD &= ~(1<<1);    //     
                        (*(unsigned char *) 0x7c) = 0x00;       //      .
                        (*(unsigned char *) 0x7a) = 0x00;
        
        button_count = 0;
        sequrity_flag = 1;  //    
        wdt_start();        //     0,5 .
        powerdown();        //  
       
  return 1;                                             
} 

void Sequrity_Process(void) { 
  unsigned char wtemp, i, count;  
  
if(ALARM_flag) { //         ,
  Step_Up_Process(); //  .
  alarm_count++;
  if(alarm_count < 32780/32) PORTD |= (1<<1);
                        else PORTD &= ~(1<<1);
                     
  if(alarm_count > 65000/32) alarm_count = 0;      
  
  if((( !(PINB & (1<<0)) )  )) button_count++;
                 else button_count = 0;    
                 
  if(button_count > 32500) {  // ~8 .  
        PORTD |= (1<<1); //  ,       .
        PWM_stop(); //  .
        sequrity_flag = 0;   //  .
        ALARM_flag = 0;  
        button_count = 0;      
        PORTB.3 = 1;   //    ( ).
        PORTB.4 = 0;
        PORTC&=~(1<<5) ;    //   .
        DDRB&=~(1<<5);   
        (*(unsigned char *) 0x7c) = 0x00;       //  .
        (*(unsigned char *) 0x7a) = 0x00;
        delay_ms(20); 
        PORTD &= ~(1<<1);  //  .
        DDRB&=~(1<<7); //  ,         .    
        while((( !(PINB & (1<<0)) )  ));
        delay_ms(3000);
        #asm("sei")
        powerdown(); 
        }
                
} else {
  PORTC|=(1<<5)  ;   
  (*(unsigned char *) 0x7a)=0x81; //  

  delay_ms(4); //    .
  temp = read_adc(0x60   | 3);  //    . 
   
  //     ,      :
  wtemp = read_adc(0x60   | 2                               );   
  if( (wtemp > max_X) || (wtemp < min_X) ) {
        #asm("cli")   
        count = 0;
        for(i=0;i<5;i++) {
                wtemp = read_adc(0x60   | 2                               ); 
                if( (wtemp > max_X) || (wtemp < min_X) ) count++; 
                }
        if(count > 2) ALARM_flag = 1; 
        #asm("sei")        
        }

  wtemp = read_adc(0x60   | 3);   
  if( (wtemp > max_Y) || (wtemp < min_Y) ) {
        #asm("cli")   
        count = 0;
        for(i=0;i<5;i++) {
                wtemp = read_adc(0x60   | 3); 
                if( (wtemp > max_Y) || (wtemp < min_Y) ) count++; 
                }
        if(count > 2) ALARM_flag = 1; 
        #asm("sei")        
        }

  wtemp = read_adc(0x60   | 4);   
  if( (wtemp > max_Z) || (wtemp < min_Z) ) {
        #asm("cli")   
        count = 0;
        for(i=0;i<5;i++) {
                wtemp = read_adc(0x60   | 4); 
                if( (wtemp > max_Z) || (wtemp < min_Z) ) count++; 
                }
        if(count > 2) ALARM_flag = 1; 
        #asm("sei")        
        } 
   
  PORTC&=~(1<<5) ; //    
           
  if((( !(PINB & (1<<0)) )  )) {  //      ,     .
                         #asm("cli") 
                         but_count = 0; 
                         while( (( !(PINB & (1<<0)) )  ) && (but_count < 32500)) { // ,   .
                                but_count++; 
                                delay_us(100);
                                }     
                             
                         if( but_count < 32500 ) { //        ( ~3 ) 
                                if(but_count > 100) { //    0,1  (    )
                                                     ALARM_flag = 1;  //     
                                                    }
                                
                                } else { 
                                        ALARM_flag = 0; 
                                        bt_flag = 1;    
                                        PORTB.3 = 1;   //    ( ).
                                        PORTB.4 = 0;
                                }
                         #asm("sei")        
                        }

       

  if(ALARM_flag) { //        ,
        wdt_stop();   //  .
        DDRB|=(1<<7);   //    ,    .  
        PORTB.3 = 0;  //    ( ).
        PORTB.4 = 1;
    } else {              
        (*(unsigned char *) 0x7c) = 0x00;       //      .
        (*(unsigned char *) 0x7a) = 0x00;
 
        if(bt_flag) Go_To_Sleep();      //   .
               else powerdown();        //  
    }
 
} // end of "} else {"

}


// Declare your global variables here

void main(void)
{       
//unsigned char ch_temp;

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=P 
PORTB=0x01;
DDRB=0x00;         

// :   PB3  PB4    .
DDRB |= ((1<<3)|(1<<4));
PORTB.3 = 1;
PORTB.4 = 0;
// ********************************

// Port C initialization
// Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State6=T State5=0 State4=T State3=T State2=T State1=0 State0=0 
PORTC=0x00;
DDRC=0x23;

// Port D initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=Out Func0=In 
// State7=T State6=T State5=0 State4=T State3=T State2=T State1=0 State0=T 
PORTD=0x00;
DDRD=0x22;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
(*(unsigned char *) 0x80)=0x00;
(*(unsigned char *) 0x81)=0x00;
(*(unsigned char *) 0x85)=0x00;
(*(unsigned char *) 0x84)=0x00;
(*(unsigned char *) 0x87)=0x00;
(*(unsigned char *) 0x86)=0x00;
(*(unsigned char *) 0x89)=0x00;
(*(unsigned char *) 0x88)=0x00;
(*(unsigned char *) 0x8b)=0x00;
(*(unsigned char *) 0x8a)=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
(*(unsigned char *) 0xb6)=0x00;
(*(unsigned char *) 0xb0)=0x00;
(*(unsigned char *) 0xb1)=0x00;
(*(unsigned char *) 0xb2)=0x00;
(*(unsigned char *) 0xb3)=0x00;
(*(unsigned char *) 0xb4)=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: On
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
(*(unsigned char *) 0x69)=0x00;
EIMSK=0x00;
(*(unsigned char *) 0x68)=0x01;
(*(unsigned char *) 0x6b)=0x01;
PCIFR=0x01;

// Timer/Counter 0 Interrupt(s) initialization
(*(unsigned char *) 0x6e)=0x00;
// Timer/Counter 1 Interrupt(s) initialization
(*(unsigned char *) 0x6f)=0x00;
// Timer/Counter 2 Interrupt(s) initialization
(*(unsigned char *) 0x70)=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
(*(unsigned char *) 0x7b)=0x00;

// ADC initialization
// ADC Clock frequency: 500,000 kHz
// ADC Voltage Reference: AVCC pin
// ADC Auto Trigger Source: None
// Only the 8 most significant bits of
// the AD conversion result are used
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
// ADC4: On, ADC5: On
(*(unsigned char *) 0x7e)=0x00;
//ADMUX = 0x60 & 0xff;
//ADCSRA=0x81; 
(*(unsigned char *) 0x7c) = 0x00;       //      .
(*(unsigned char *) 0x7a) = 0x00;
  
sleep_enable(); //     .                
delay_ms(1000);
#asm("sei")  //  .
powerdown(); //   . 

delay_ms(4); //       . 
sleep_mode_flag = 0; //  
#asm("cli")   //  .
StartUp();    //   .

  
while (1)
      {
      // ----         ----
      if((( !(PINB & (1<<0)) )  ) && (sequrity_flag == 0)) {  //         ... 
                         time_of_pressed = 0; 
                         PWM_stop(); //     PWM
                         while( (( !(PINB & (1<<0)) )  ) && (time_of_pressed < 250)) { // ,   .
                                time_of_pressed++;
                                delay_ms(12);
                                } 
                         if( time_of_pressed < 250 ) { //        ( ~3 )    
                         
                                        if(time_of_pressed > 10) { //    0,1  (    )
                                                                  Prepare_of_sequrity(); //      .       
                                                                 }
                                        
                                } else {
                                  sequrity_flag = 0; 
                                  PORTB.3 = 1;   //    ( ).
                                  PORTB.4 = 0;
                                  Go_To_Sleep();  //    .
                                }
                        }
                         
        // ----       ----                
        if(sleep_mode_flag) {     
                             sleep_mode_flag = 0;  
                             #asm("cli")
                             StartUp(); //     
                            }   

        // ----     ----                
        if(sequrity_flag) Sequrity_Process(); //   -     .                
      };
}
